# Vue

A tutorial showing how to add the SpreadJS Designer Component to a Vue app, including code examples

## Content

You can perform the following steps to add the SpreadJS Designer Component to a Vue application:

## Vue 3

1. Create a Vue project by typing the following command in Command Prompt.

    ```Shell
    npm init vue@latest
    ```

    The command will present prompts for the project name and other optional features that can be added to the Vue project.
2. Import the following SpreadJS and SpreadJS Designer Vue modules in the project.

    ```Shell
    npm install @mescius/spread-sheets-designer
    npm install @mescius/spread-sheets-designer-resources-en
    npm install @mescius/spread-sheets-designer-vue
    npm install @mescius/spread-sheets
    npm install @mescius/spread-sheets-io
    npm install @mescius/spread-sheets-barcode
    npm install @mescius/spread-sheets-charts
    npm install @mescius/spread-sheets-languagepackages
    npm install @mescius/spread-sheets-print
    npm install @mescius/spread-sheets-pdf
    npm install @mescius/spread-sheets-shapes
    npm install @mescius/spread-sheets-pivot-addon
    npm install @mescius/spread-sheets-tablesheet
    ```
3. Register SpreadJS Designer Vue Component to the application in the main.js file.

    ```JavaScript
    import { createApp } from 'vue'
    import App from './App.vue'
    import Designer from "@mescius/spread-sheets-designer-vue"
    let app = createApp(App);
    app.component("gc-spread-sheets-designer", Designer);
    app.mount('#app');
    ```
4. Add the SpreadJS Designer Vue Component to the application by modifying the App.vue file.

    ```Vue
    <script setup>
    import '@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css';
    import "@mescius/spread-sheets-designer/styles/gc.spread.sheets.designer.min.css";
    import * as GC from "@mescius/spread-sheets";
    import "@mescius/spread-sheets-print";
    import "@mescius/spread-sheets-shapes";
    import "@mescius/spread-sheets-pivot-addon";
    import "@mescius/spread-sheets-tablesheet";
    import "@mescius/spread-sheets-designer-resources-en";
    import "@mescius/spread-sheets-designer";
    </script>
    <script>
    export default {
      name: "App",
      data: function () {
        return {
          styleInfo: { height: "98vh", width: "100%" },
          config: config,
          spreadOptions: {
            sheetCount: 2,
          },
          designer: null,
        };
      },
      methods: {
        designerInitialized(value) {
          this.designer = value;
        },
      },
    };
    </script>
    <template>
      <div id="gc-designer-container">
        <gc-spread-sheets-designer
          :styleInfo="styleInfo"
          :config="config"
          :spreadOptions="spreadOptions"
          @designerInitialized="designerInitialized"/>
      </div>
    </template>
    <style>
    </style>
    ```
5. Run the application.

    ```Shell
    npm run dev
    ```

## Vue with Typescript

1. Create a Vue project by typing the following command in Command Prompt.

    ```Shell
    npm init vue@latest sjs-designer-vue-app
    cd sjs-designer-vue-app
    ```

    The command will prompt for the other optional features that can be added to the Vue project.
2. Select Yes for the "Add TypeScript" query.
<br>
    ![vue3 with ts in designer](https://cdn.mescius.io/document-site-files/images/7719ad0a-f083-46d7-aff6-f63e2e187c15/vue3%20with%20ts%20in%20designer.001944.png?width=600)
<br>
3. Install the following npm packages.

    ```Shell
    npm install
    npm install @mescius/spread-sheets-designer
    npm install @mescius/spread-sheets-designer-resources-en
    npm install @mescius/spread-sheets-designer-vue
    npm install @mescius/spread-sheets
    npm install @mescius/spread-sheets-barcode
    npm install @mescius/spread-sheets-shapes
    npm install @mescius/spread-sheets-charts
    npm install @mescius/spread-sheets-slicers
    npm install @mescius/spread-sheets-languagepackages
    npm install @mescius/spread-sheets-print
    npm install @mescius/spread-sheets-pdf
    npm install @mescius/spread-sheets-pivot-addon
    npm install @mescius/spread-sheets-tablesheet
    npm install @mescius/spread-sheets-ganttsheet
    npm install @mescius/spread-sheets-reportsheet-addon
    npm install @mescius/spread-sheets-formula-panel
    npm install @mescius/spread-sheets-io
    ```
4. Add the SpreadJS Designer Vue Component to the application and use TypeScript with \<script setup> by modifying the App.vue file.

    ```Vue
    <template>
      <div id="app">
        <Designer :styleInfo="styleInfo" :config="config" :spreadOptions="spreadOptions"
          @designerInitialized="designerInitialized">
        </Designer>
      </div>
    </template>
    
    <script setup lang="ts">
    import '@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css';
    import "@mescius/spread-sheets-designer/styles/gc.spread.sheets.designer.min.css";
    import * as GC from "@mescius/spread-sheets";
    import "@mescius/spread-sheets-print";
    import "@mescius/spread-sheets-shapes";
    import "@mescius/spread-sheets-charts";
    import "@mescius/spread-sheets-slicers";
    import "@mescius/spread-sheets-pivot-addon";
    import "@mescius/spread-sheets-tablesheet";
    import "@mescius/spread-sheets-ganttsheet";
    import "@mescius/spread-sheets-reportsheet-addon";
    import "@mescius/spread-sheets-formula-panel";
    import "@mescius/spread-sheets-io";
    import "@mescius/spread-sheets-designer-resources-en";
    import Designer from "@mescius/spread-sheets-designer-vue";
    
    // eslint-disable-next-line @typescript-eslint/no-explicit-any
    const config = (GC.Spread.Sheets as any).Designer.DefaultConfig;
    
    if ((config).ribbon[0].buttonGroups[0].commandGroup.children[0].commands[0] !== "Welcome") {
      config.commandMap = {
        Welcome: {
          title: "Welcome",
          text: "Welcome",
          iconClass: "ribbon-button-welcome",
          bigButton: true,
          commandName: "Welcome",
          execute: async () => {
            alert("Welcome to new designer.");
          },
        },
      };
    
      // eslint-disable-next-line @typescript-eslint/no-explicit-any
      (config as any).ribbon[0].buttonGroups.unshift({
        label: "NewDesigner",
        thumbnailClass: "welcome",
        commandGroup: {
          children: [
            {
              direction: "vertical",
              commands: ["Welcome"],
            },
          ],
        },
      });
    }
    
    const styleInfo = { height: "98vh", width: "100%" };
    const spreadOptions = {
      sheetCount: 3,
    };
    
    // eslint-disable-next-line @typescript-eslint/no-explicit-any
    function designerInitialized(value: any) {
      const spread: GC.Spread.Sheets.Workbook = value.getWorkbook();
      const activeSheet = spread.getActiveSheet();
      activeSheet.setValue(0, 0, "Sample");
    }
    
    </script>
    ```
5. Run the application.

    ```Shell
    npm run dev
    ```

## Vue 2

1. Create a Vue project by typing the following commands in Command Prompt.

    ```Shell
    npm install -g @vue/cli
    npm i -g @vue/cli-init
    vue init webpack designercomponent
    cd designercomponent
    npm run dev
    ```
2. Import the following SpreadJS Vue modules in the project.

    ```Shell
    npm install @mescius/spread-sheets
    npm install @mescius/spread-sheets-barcode
    npm install @mescius/spread-sheets-charts
    npm install @mescius/spread-sheets-languagepackages
    npm install @mescius/spread-sheets-pdf
    npm install @mescius/spread-sheets-print
    npm install @mescius/spread-sheets-shapes
    npm install @mescius/spread-sheets-tablesheet
    npm install @mescius/spread-sheets-pivot-addon
    npm install @mescius/spread-sheets-designer
    npm install @mescius/spread-sheets-designer-resources-en
    npm install @mescius/spread-sheets-vue
    npm install @mescius/spread-sheets-designer-vue 
    npm install @mescius/spread-sheets-io
    ```
3. Import the required modules and add the designer tag into the template using the following code snippet in App.vue.

    ```Vue
    <!--Add designer tag into the template-->
    <template>
      <div id="app">
        <gc-spread-sheets-designer :styleInfo='styleInfo'
                                   :config='config'
                                   @designerInitialized="designerInitialized">
        </gc-spread-sheets-designer>
      </div>
    </template>
    <script>
    // import the required modules
    import '@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css'
    import '@mescius/spread-sheets-designer/styles/gc.spread.sheets.designer.min.css'
    import '@mescius/spread-sheets-designer-resources-en'
    import '@mescius/spread-sheets-designer-vue'
    export default {
      name: 'App',
      data: function () {
        return {
          styleInfo: { height: '800px', width: '1200px', border: 'solid black 1px' },
          config: null,
          designer: null
        }
      },
      methods: {
        designerInitialized (value) {
          this.designer = value
        }
      }
    }
    </script>
    ```
4. Run the application.

    ```Shell
    npm run dev
    ```

## Apply License

The licensed version allows you to use all features of the SpreadJS Designer Component. You need to set the license key for SpreadJS and the Designer Component which can be done by using the following code snippet.

```JavaScript
import '@mescius/spread-sheets-designer-resources-en';
import { Designer } from '@mescius/spread-sheets-designer-vue';
import * as GC from '@mescius/spread-sheets';
import "@mescius/spread-sheets-io";

// license keys
var sjsLicense = 'sjs-distribution-key'
GC.Spread.Sheets.LicenseKey = sjsLicense
GC.Spread.Sheets.Designer.LicenseKey = 'designer-component-distribution-key'
```

# Angular

A tutorial showing how to add the SpreadJS Designer Component to an Angular app, including code examples

## Content

You can perform the following steps to add the SpreadJS Designer Component to an Angular application:

1. Create an Angular project by typing the following commands in **Command Prompt**.

    ```Shell
    npm install -g @angular/cli
    ng new designercomponent --style css --ssr false
    cd designercomponent
    ```
2. Import the following SpreadJS modules in the project to use SpreadJS Designer Component.

    ```Shell
    npm install @mescius/spread-sheets
    npm install @mescius/spread-sheets-angular
    npm install @mescius/spread-sheets-shapes
    npm install @mescius/spread-sheets-charts
    npm install @mescius/spread-sheets-slicers
    npm install @mescius/spread-sheets-print
    npm install @mescius/spread-sheets-formula-panel
    npm install @mescius/spread-sheets-barcode
    npm install @mescius/spread-sheets-pdf
    npm install @mescius/spread-sheets-pivot-addon
    npm install @mescius/spread-sheets-tablesheet
    npm install @mescius/spread-sheets-ganttsheet
    npm install @mescius/spread-sheets-reportsheet-addon
    npm install @mescius/spread-sheets-languagepackages
    npm install @mescius/spread-sheets-io
    npm install @mescius/spread-sheets-designer
    npm install @mescius/spread-sheets-designer-resources-en
    npm install @mescius/spread-sheets-designer-angular
    ```
3. Import CSS file in the **app.component.css** file using the following code snippet.

    ```TypeScript
    @import '@mescius/spread-sheets-designer/styles/gc.spread.sheets.designer.min.css';
    @import '@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css';
    ```
4. Add the designer tag in the **app.component.html** file using the following code snippet.

    ```TypeScript
    <designer [props]="props"></designer>
    ```
5. To configure the designer, you may pass the `props` parameters as shown below in the **app.component.ts** file.

    ```TypeScript
    import { Component, ViewEncapsulation } from '@angular/core';
    import * as GC from '@mescius/spread-sheets';
    import "@mescius/spread-sheets-shapes";
    import "@mescius/spread-sheets-charts";
    import "@mescius/spread-sheets-slicers";
    import "@mescius/spread-sheets-print";
    import "@mescius/spread-sheets-formula-panel";
    import "@mescius/spread-sheets-barcode";
    import "@mescius/spread-sheets-pdf";
    import "@mescius/spread-sheets-pivot-addon";
    import "@mescius/spread-sheets-tablesheet";
    import "@mescius/spread-sheets-ganttsheet";
    import "@mescius/spread-sheets-reportsheet-addon";
    import "@mescius/spread-sheets-io";
    import '@mescius/spread-sheets-designer-resources-en';
    import '@mescius/spread-sheets-designer';
    import * as GcDesigner from '@mescius/spread-sheets-designer';
    import { DesignerModule } from '@mescius/spread-sheets-designer-angular';
    
    @Component({
      selector: 'app-root',
      standalone: true,
      imports: [DesignerModule],
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css'],
      encapsulation: ViewEncapsulation.None
    })
    export class AppComponent {
        props = {
           styleInfo: "width: 100%; height: 98vh; margin-top: 10px", 
        };
    }
    ```
6. Save and run the application.

    ```Shell
    npm start
    ```

## Access SpreadJS instance

You can also access the SpreadJS instance by using `designerInitialized` event. Follow steps 1 to 4 as listed above and continue:

1. Add an event listener to the `designerInitialized` event in the **app.component.html** file using the following code snippet.

    ```TypeScript
    <designer (designerInitialized)="afterDesignerInit($event)" [props]="props"></designer>
    ```
2. Update the **app.component.ts** file using the following code snippet.

    ```TypeScript
    export class AppComponent {
        props = {
           styleInfo: "width: 100%; height: 700px",
           config: null
        }
        afterDesignerInit(e: { designer:GcDesigner.Spread.Sheets.Designer.Designer }) {
    
           // this is hosted spread instance
           var workbook = e.designer.getWorkbook() as GC.Spread.Sheets.Workbook;
           var sheet = workbook.getActiveSheet();
           sheet.setValue(1, 1, 'Test');
        }
    }
    ```
3. Save and run the application.

    ```Shell
    npm start
    ```

## Apply License

The licensed version allows you to use all the features of the SpreadJS Designer Component. You need to set the license key for SpreadJS and the Designer Component which can be done by using the following code snippet.

```TypeScript
import { Component, ViewEncapsulation } from '@angular/core';
import * as GC from '@mescius/spread-sheets';
import "@mescius/spread-sheets-shapes";
import "@mescius/spread-sheets-charts";
import "@mescius/spread-sheets-slicers";
import "@mescius/spread-sheets-print";
import "@mescius/spread-sheets-formula-panel";
import "@mescius/spread-sheets-barcode";
import "@mescius/spread-sheets-pdf";
import "@mescius/spread-sheets-pivot-addon";
import "@mescius/spread-sheets-tablesheet";
import "@mescius/spread-sheets-ganttsheet";
import "@mescius/spread-sheets-reportsheet-addon";
import "@mescius/spread-sheets-io";
import '@mescius/spread-sheets-designer-resources-en';
import '@mescius/spread-sheets-designer';
import * as GcDesigner from '@mescius/spread-sheets-designer';
import { DesignerModule } from '@mescius/spread-sheets-designer-angular';
 
var sjsLicense = "sjs-distribution-key";
GC.Spread.Sheets.LicenseKey = sjsLicense;
 
(GC.Spread.Sheets as any).Designer.LicenseKey = "designer-component-distribution-key";
```

## Limitation

When building an Angular application with SpreadJS packages (including the SpreadJS Designer Component), you may encounter an error message "*An unhandled exception occurred: Map maximum size exceeded*." This issue occurs only when the Angular application uses localization and is built with the ESbuild bundler. It happens because the SpreadJS packages are in CommonJS format, and ESbuild does not support tree-shaking for CommonJS modules.

# React

A tutorial showing how to add the SpreadJS Designer Component to a React app, including code examples

## Content

You can perform the following steps to add the SpreadJS Designer Component in a React application:

1. Create a React project by typing the following commands in Command Prompt.

    ```Shell
    npm install -g create-react-app
    create-react-app designercomponent
    cd designercomponent
    npm start
    ```
2. Install the following SpreadJS React modules to use SpreadJS Designer Component.

    ```Shell
    npm install @mescius/spread-sheets
    npm install @mescius/spread-sheets-io
    npm install @mescius/spread-sheets-barcode
    npm install @mescius/spread-sheets-charts
    npm install @mescius/spread-sheets-languagepackages
    npm install @mescius/spread-sheets-pdf
    npm install @mescius/spread-sheets-print
    npm install @mescius/spread-sheets-shapes
    npm install @mescius/spread-sheets-tablesheet
    npm install @mescius/spread-sheets-pivot-addon
    npm install @mescius/spread-sheets-designer
    npm install @mescius/spread-sheets-designer-resources-en
    npm install @mescius/spread-sheets-react
    npm install @mescius/spread-sheets-designer-react
    ```
3. Import the required modules using the following code snippet in App.js.

    ```JavaScript
    import '@mescius/spread-sheets-designer-resources-en';
    import {Designer} from '@mescius/spread-sheets-designer-react';
    import '@mescius/spread-sheets-designer/styles/gc.spread.sheets.designer.min.css'
    import '@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css'
    ```
4. Render the Designer Component using the following code snippet in App.js.

    ```JavaScript
    function App() {
       return (
          <Designer styleInfo = {{width: "1500px", height: '90vh'}}></Designer>
       );
    }
    export default App;
    ```
5. Run the application.

    ```Shell
    npm start
    ```

## Access SpreadJS instance

You can also access the SpreadJS instance by using `designerInitialized` event. Follow steps 1, 2, and 3 as listed above and continue:

1. To render the Designer Component and access the SpreadJS instance, you can use the following code snippet.

    ```JavaScript
    function App() {
        return (
            <Designer designerInitialized={designer => { getDesigner(designer) }}
            styleInfo={{ width: "100%", height: '98vh' }}></Designer >
        );
    }
    // Function to get designer
    function getDesigner(designer) {
        //this is hosted spread instance
        var workbook = designer.getWorkbook();
        var sheet = workbook.getActiveSheet(); sheet.setValue(1, 1, 'Test');
    }
    ```

### Apply License

The licensed version allows you to use all features of the SpreadJS Designer Component. You need to set the license key for SpreadJS and the Designer Component which can be done by using the following code snippet.

```JavaScript
import React from 'react';
import '@mescius/spread-sheets-designer-resources-en';
import * as GC from '@mescius/spread-sheets';
import '@mescius/spread-sheets-designer';
import {Designer} from '@mescius/spread-sheets-designer-react';
import "@mescius/spread-sheets-io";
 
var sjsLicense = "sjs-distribution-key";
GC.Spread.Sheets.LicenseKey = sjsLicense;
 
GC.Spread.Sheets.Designer.LicenseKey = " designer-component-distribution-key ";
```